<?php

/*
 * Copyright (C) 2014, NoccyLabs
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 */

namespace NoccyLabs\Gpio;

interface GpioMapperInterface
{
    /**
     * Map the GPIO pin numbers to a more logical number set, such as that of 
     * wiringPi.
     */
    public function mapGpioToLogicalPin($gpio);
    
    /**
     * Map a logical pin number, such as the ones used by wiringPi, into the
     * actual GPIO pin number.
     *
     */
     public function mapLogicalToGpioPin($logical);

}
